import static org.junit.Assert.*;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.junit.Test;

public class TransactionTest {
    String url = "jdbc:mysql://localhost:3306/test";
    String userName = "root";
    String password = "123456";
    String driverName = "com.mysql.jdbc.Driver";
    String sql1 = "update account set balance = balance - 100 where name = ?";
    String sql2 = "update account set balance = balance + 100 where name = ?";
    @Test
    public void test() {
        Connection con = null;
        PreparedStatement pstmt = null;
        ResultSet rs = null;
        boolean throwFlag = false;
       
        
        try {
            Class.forName(driverName); // 加载MySql的驱动程序
            con = DriverManager.getConnection(url, userName, password);
            con.setAutoCommit(false);
            pstmt = con.prepareStatement(sql1);
            pstmt.setString(1, "a");
            pstmt.executeUpdate();
            if (!throwFlag){
                throw new SQLException("主动抛出的异常");
            }
            pstmt = con.prepareStatement(sql2);
            pstmt.setString(1, "b");
            pstmt.executeUpdate();
            con.commit();
            
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
            if (con != null) {
                try{
                    System.err.print("事务正在回滚");
                    con.rollback();
                } catch(SQLException excep) {
                    excep.printStackTrace();
                }
            }
        }
    }

}
