package dao;

import java.util.ArrayList;
import java.util.List;

import model.Student;

/**
 * 内部使用数组的版本实现
 * 
 * @author zhrb
 *
 */
public class StudentDaoArrayImpl implements StudentDao {

	private Student[] students;
	private int size = 100;// 默认数组大小
	
	public StudentDaoArrayImpl() {
		students = new Student[size];
	}

	public StudentDaoArrayImpl(int size) {
		this.size = size;
		students = new Student[size];
	}
	
	@Override
	public List<model.Student> getStudentsByName(String name) {
		List<Student> studentList = new ArrayList<>();
		for(int i=0; i<students.length;i++){
			if(students[i]!= null){
				if (students[i].getName().contains(name)){
					studentList.add(students[i]);
				}
			}
		}
		return studentList;
	}

	@Override
	public boolean writeStudent(Student student) {
		boolean success = false;
		for (int i = 0; i < students.length; i++) {
			if (students[i] == null) {
				students[i] = student;
				success = true;
				break;
			}
		}
		return success;
	}

	@Override
	public void diplayAllStudent() {
		for (Student e : students) {
			if (e != null)
				System.out.println(e);
		}
	}

	@Override
	public List<Student> getAllStudents() {
		return null;
	}

}
