package dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import model.Student;
import utils.JDBCUtil;
/**
 * 该实现类运行需要MySql数据库test和表students
 * CREATE TABLE `students` (
  `id` int NOT NULL AUTO_INCREMENT,
  `stuno` char(10) NOT NULL,
  `name` char(20) NOT NULL,
  `gender` char(1) NOT NULL,
  `age` int DEFAULT NULL,
  `birthdate` date DEFAULT NULL,
  `major` char(20) DEFAULT NULL,
  PRIMARY KEY (`id`)
)
	
 * @author zhrb
 *
 */
public class StudentDaoJDBCImpl implements StudentDao {

	@Override
	public boolean writeStudent(Student student) {
		String sql = "insert into students(stuno,name,gender) values(?,?,?) ";//表中有id和name这列
		int result = -1;
		
		try(Connection conn = JDBCUtil.getConnection();
			PreparedStatement pstat = conn.prepareStatement(sql);) {
			pstat.setString(1, new Random().nextInt(100000)+"");
			pstat.setString(2, student.getName());
			pstat.setString(3, "m");
			result = pstat.executeUpdate();
		}catch (SQLException sqle) {
			sqle.printStackTrace();
		}catch(Exception e){
			e.printStackTrace();
		}
		return result>0?true:false;
	}

	@Override
	public List<Student> getStudentsByName(String name) {
		String sql = "select * from students where name like ?";
		List<Student> studentList = new ArrayList<>();
		try(Connection conn = JDBCUtil.getConnection();
			PreparedStatement pstat = conn.prepareStatement(sql);) {
			pstat.setString(1, name);
			ResultSet rs = pstat.executeQuery();
			while(rs.next()){
				int stuId = rs.getInt("id");
				String stuName = rs.getString("name");
				String gender = rs.getString("gender");
				Student stu = new Student(stuId, stuName);
				stu.setGender(gender);
				studentList.add(stu);
			}
		}catch (SQLException sqle) {
			sqle.printStackTrace();
		}catch(Exception e){
			e.printStackTrace();
		}
		return studentList;
	}

	@Override
	public void diplayAllStudent() {
		String sql = "select * from students";//表中有id和name这列
		try(Connection conn = JDBCUtil.getConnection();
			PreparedStatement pstat = conn.prepareStatement(sql);) {
			ResultSet rs = pstat.executeQuery(sql);
			while(rs.next()){
				int id = rs.getInt("id");
				String name = rs.getString("name");
				System.out.format("该学生的id=%d,姓名=%s\n",id,name);
			}
		}catch (SQLException sqle) {
			sqle.printStackTrace();
		}catch(Exception e){
			e.printStackTrace();
		}
	}

	/**
	 * 还未实现
	 */
	@Override
	public List<Student> getAllStudents() {
		return null;
	}
	

}
