package test;

import java.util.List;

import dao.StudenDaoListImpl;
import dao.StudentDao;
import dao.StudentDaoJDBCImpl;
import model.Student;

public class TestMain {

	/**
	 * 1分别使用了不同的实现
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		Student[] students = new Student[4];
		students[0] = new Student("Tom");
		students[1] = new Student("Jerry");
		students[2] = new Student("Sophia");
		students[3] = new Student("xxTomyy");

		//StudentDao stuDao = new StudentDaoArrayImpl(50);// 使用数组实现
		// StudentDao stuDao = new StudenDaoListImpl();//使用列表实现
		StudentDao stuDao = new StudentDaoJDBCImpl();//使用JDBC实现

		// 下面的代码，无需关心后台到底是文件、数据库、数组、List
		// 因为这里是面向StudentDao接口进行编程,所以不管上面怎么修改，下面代码可以不用改动
		System.out.println("===========写入学生========");
		for (Student e : students) {
			if (!stuDao.writeStudent(e)) {
				System.out.println("添加学生失败");
			} else {
				System.out.println("插入成功！！");
			}
		}
		System.out.println("===========显示所有学生========");
		stuDao.diplayAllStudent();
		System.out.println("===========查询学生========");
		List<Student> stuList = stuDao.getStudentsByName("Tom");
		if (stuList.size() == 0) {
			System.out.println("查无此人");
		} else {
			for (Student e : stuList) {
				System.out.println(e);
			}
		}

	}

}
